#include <cvidef.h>
#include <vpptype.h>

// D3186_set_pattern_mode() - pattern_mode_id values
#define	D3186_PATTERN_TYPE_PRBS		1
#define	D3186_PATTERN_TYPE_WORD		2
#define	D3186_PATTERN_TYPE_FRAME	3

// D3186_set_mark_ratio() - mark_ratio_id values
#define	D3186_MARK_RATIO_0_8		1
#define	D3186_MARK_RATIO_1_8		2
#define	D3186_MARK_RATIO_1_4		3
#define	D3186_MARK_RATIO_1_2		4
#define	D3186_MARK_RATIO_8_8		5
#define	D3186_MARK_RATIO_7_8		6
#define	D3186_MARK_RATIO_3_4		7
#define	D3186_MARK_RATIO_1_2_B		8

// D3186_set_alternate_mode() - alternate_mode_state values
#define	D3186_ALTERNATE_MODE_OFF	0
#define	D3186_ALTERNATE_MODE_ON		1

// D3186_select_alternate_pattern() - alternate_pattern_id values
#define	D3186_ALTERNATE_PATTERN_A	1
#define	D3186_ALTERNATE_PATTERN_B	2

// D3186_set_polarity() - polarity_id values
#define	D3186_POLARITY_NORMAL		1
#define	D3186_POLARITY_INVERTED		2

// D3186_set_payload_type() - payload_type_id values
#define	D3186_PAYLOAD_WORD			1
#define	D3186_PAYLOAD_PRBS			2
#define	D3186_PAYLOAD_CID			3

// D3186_configure_output() - output_id values
#define	D3186_OUTPUT_ID_DATA		1
#define	D3186_OUTPUT_ID_DATA_NOT	2
#define	D3186_OUTPUT_ID_CLOCK1		3
#define	D3186_OUTPUT_ID_CLOCK1_NOT	4

// D3186_configure_output() - output_mode_id values
#define	D3186_OUTPUT_MODE_AC		1
#define	D3186_OUTPUT_MODE_TO_2V		2
#define	D3186_OUTPUT_MODE_TO_0V		3

// D3186_configure_output() - offset_mode_id values
#define	D3186_OFFSET_LEVEL_HIGH		1
#define	D3186_OFFSET_LEVEL_MID		2
#define	D3186_OFFSET_LEVEL_LOW		3

// D3186_configure_output() - adjust_enable values
#define	D3186_ADJUST_ENABLE_OFF		0
#define	D3186_ADJUST_ENABLE_ON		1

// D3186_load_file() and D3186_save_file() - file_type_id values
#define	D3186_FILE_TYPE_SETUP		1
#define	D3186_FILE_TYPE_WORD_PAT	2

// D3186_set_error_addition_rate() - negative_of_exponent values
#define	D3186_ERRADD_RATE_SINGLE	-1
#define	D3186_ERRADD_RATE_EXT		-2

void CVIFUNC D3186_configure_and_measure (ViUInt32 count_n);

ViStatus CVIFUNC D3186_set_clock_rate (ViSession instrSession,
                                       ViUInt32 clock_rate_khz);

ViStatus CVIFUNC D3186_set_pattern_mode (ViSession instrSession,
                                         int pattern_mode_id);

ViStatus CVIFUNC D3186_set_prbs_count_n (ViSession instrSession,
                                         ViUInt32 count_n);

ViStatus CVIFUNC D3186_set_mark_ratio (ViSession instrSession, int mark_ratio_id);

ViStatus CVIFUNC D3186_set_pattern_trigger_address (ViSession instrSession,
                                                    ViUInt32 trigger_address);

ViStatus CVIFUNC D3186_set_prbs_pattern_trigger_addr (ViSession instrSession,
                                                      ViUInt32 prbs_trigger_address);

ViStatus CVIFUNC D3186_set_alternate_mode (ViSession instrSession,
                                           int alternate_mode_state);

ViStatus CVIFUNC D3186_select_alternate_pattern (ViSession instrSession,
                                                 int alternate_pattern_id);

ViStatus CVIFUNC D3186_set_word_pattern_length (ViSession instrSession,
                                                ViUInt32 word_pattern_length);

ViStatus CVIFUNC D3186_set_word_pattern_trigger_addr (ViSession instrSession,
                                                      ViUInt32 word_pattern_trigger_address);

ViStatus CVIFUNC D3186_send_word_pattern (ViSession instrSession,
                                          ViUInt32 word_address,
                                          ViUInt32 word_byte_count,
                                          unsigned char words_sent[]);

ViStatus CVIFUNC D3186_send_word_alternate_pattern (ViSession instrSession,
                                                    int word_alternate_pattern_id,
                                                    ViUInt32 word_address,
                                                    ViUInt32 word_byte_count,
                                                    unsigned char words_sent[]);

ViStatus CVIFUNC D3186_set_polarity (ViSession instrSession, int polarity_id);

ViStatus CVIFUNC D3186_set_payload_type (ViSession instrSession,
                                         int payload_type_id);

ViStatus CVIFUNC D3186_set_frame_structure (ViSession instrSession,
                                            ViUInt32 frame_count,
                                            ViUInt32 row_count,
                                            ViUInt32 byte_count_per_row,
                                            ViUInt32 overhead_byte_count,
                                            ViUInt32 cid_bit_count);

ViStatus CVIFUNC D3186_set_frame_pattern_trigger (ViSession instrSession,
                                                  ViUInt32 frame_number,
                                                  ViUInt32 row_number,
                                                  ViUInt32 byte_number);

ViStatus CVIFUNC D3186_send_frame_pattern (ViSession instrSession,
                                           ViUInt32 frame_number,
                                           ViUInt32 row_number,
                                           ViUInt32 byte_number,
                                           ViUInt32 frame_byte_count,
                                           unsigned char frame_pattern_sent[]);

ViStatus CVIFUNC D3186_send_frame_alternate_pattern (ViSession instrSession,
                                                     int frame_alternate_pattern_id,
                                                     ViUInt32 frame_number,
                                                     ViUInt32 row_number,
                                                     ViUInt32 byte_number,
                                           			 ViUInt32 frame_byte_count,
                                                     unsigned char frame_pattern_sent[]);

ViStatus CVIFUNC D3186_set_frame_polarity (ViSession instrSession,
                                           int polarity_id);

ViStatus CVIFUNC D3186_set_error_addition_rate (ViSession instrSession,
                                                ViInt16 negative_of_exponent);

ViStatus CVIFUNC D3186_output_state (ViSession instrSession, int state);

ViStatus CVIFUNC D3186_configure_output (ViSession instrSession, int output_id,
                                         int output_mode_id, int offset_mode_id,
                                         ViReal64 amplitude_volt_pp,
                                         ViReal64 output_offset,
                                         int adjust_enable);

ViStatus CVIFUNC D3186_configure_DATA_output (ViSession instrSession,
                                              ViReal64 amplitude_volt_pp,
                                              ViReal64 output_offset);

ViStatus CVIFUNC D3186_configure_DATA_Bar_output (ViSession instrSession,
                                                  ViReal64 amplitude_volt_pp,
                                                  ViReal64 output_offset);

ViStatus CVIFUNC D3186_configure_CLOCK_output (ViSession instrSession,
                                               ViReal64 amplitude_volt_pp,
                                               ViReal64 output_offset);

ViStatus CVIFUNC D3186_configure_CLOCK_Bar_output (ViSession instrSession,
                                                   ViReal64 amplitude_volt_pp,
                                                   ViReal64 output_offset);

ViStatus CVIFUNC D3186_set_clock_delay (ViSession instrSession,
                                        ViInt32 clock_delay_ps);

ViStatus CVIFUNC D3186_load_file (ViSession instrSession, int file_type_id,
                                  ViUInt32 file_number);

ViStatus CVIFUNC D3186_save_file (ViSession instrSession, int file_type_id,
                                  ViUInt32 file_number);
