#include <cvidef.h>
#include <vpptype.h>

#define VI_ERROR_PARAMETER9       (_VI_ERROR+0x3FFC0009L)

// D3286_configure_auto_sync() - state_id values
// D3286_configure_frame_sync_for_word_pattern() - sync_state_id values
// D3286_configure_frame_sync_for_frame_pattern() - sync_state_id values
// D3286_configure_data_buzzer() - buzzer_state_id values
// D3286_configure_alarm_buzzer() - buzzer_state_id values
// D3286_set_alternate_mode() - alternate_mode_state values
#define	D3286_ALTERNATE_MODE_OFF					0
#define	D3286_ALTERNATE_MODE_ON						1

// D3286_configure_data_output() - terminator_voltage_id values
#define	D3286_TERM_VOLTAGE_TO_0V					1
#define	D3286_TERM_VOLTAGE_TO_2V					2

// D3286_set_pattern_mode() - pattern_mode_id values
#define	D3286_PATTERN_TYPE_PRBS						1
#define	D3286_PATTERN_TYPE_WORD						2
#define	D3286_PATTERN_TYPE_FRAME					3

// D3286_set_mark_ratio() - mark_ratio_id values
#define	D3286_MARK_RATIO_0_8						1
#define	D3286_MARK_RATIO_1_8						2
#define	D3286_MARK_RATIO_1_4						3
#define	D3286_MARK_RATIO_1_2						4
#define	D3286_MARK_RATIO_8_8						5
#define	D3286_MARK_RATIO_7_8						6
#define	D3286_MARK_RATIO_3_4						7
#define	D3286_MARK_RATIO_1_2_B						8

// D3286_configure_trigger_output() - trigger_type_id values
#define	D3286_TRIGGER_OUTPUT_1_32_CLOCK				1
#define	D3286_TRIGGER_OUTPUT_PATTERN_SYNC			2

// D3286_select_alternate_pattern(),
// D3286_load_file() and
// D3286_save_file() - alternate_pattern_id values
#define	D3286_ALTERNATE_PATTERN_A					1
#define	D3286_ALTERNATE_PATTERN_B					2

// D3286_set_polarity() - polarity_id values
#define	D3286_POLARITY_NORMAL						1
#define	D3286_POLARITY_INVERTED						2

// D3286_set_payload_type() - payload_type_id values
#define	D3286_PAYLOAD_WORD							1
#define	D3286_PAYLOAD_PRBS							2
#define	D3286_PAYLOAD_CID							3

// D3286_configure_output() - output_id values
#define	D3286_OUTPUT_ID_DATA						1
#define	D3286_OUTPUT_ID_DATA_NOT					2
#define	D3286_OUTPUT_ID_CLOCK1						3
#define	D3286_OUTPUT_ID_CLOCK1_NOT					4

// D3286_configure_output() - output_mode_id values
#define	D3286_OUTPUT_MODE_AC						1
#define	D3286_OUTPUT_MODE_TO_2V						2
#define	D3286_OUTPUT_MODE_TO_0V						3

// D3286_configure_output() - offset_mode_id values
#define	D3286_OFFSET_LEVEL_HIGH						1
#define	D3286_OFFSET_LEVEL_MID						2
#define	D3286_OFFSET_LEVEL_LOW						3

// D3286_configure_output() - adjust_enable values
#define	D3286_ADJUST_ENABLE_OFF						0
#define	D3286_ADJUST_ENABLE_ON						1

// D3286_load_file() and D3286_save_file() - file_type_id values
#define	D3286_FILE_TYPE_SETUP						1
#define	D3286_FILE_TYPE_WORD_PAT					2
#define	D3286_FILE_TYPE_FRAME						3
#define	D3286_FILE_TYPE_MEAS						4

// D3286_set_measurement_function() - meas_fct_id values
#define	D3286_MEAS_FCT_ERROR_RATE					1
#define	D3286_MEAS_FCT_ERROR_COUNT					2
#define	D3286_MEAS_FCT_ERROR_INTERVAL				3
#define	D3286_MEAS_FCT_ERROR_FREE_INTERVAL			4
#define	D3286_MEAS_FCT_FREQUENCY					5
#define	D3286_MEAS_FCT_FRAME_COUNT					6

// D3286_set_measurement_mode() - meas_mode_id values
#define	D3286_MEAS_MODE_OMISSION					1
#define	D3286_MEAS_MODE_INSERTION					2
#define	D3286_MEAS_MODE_TOTAL_ERROR					3
#define	D3286_MEAS_MODE_OVERHEAD_ERROR				4
#define	D3286_MEAS_MODE_PAYLOAD_SECTION				5
#define	D3286_MEAS_MODE_ENTIRE_FRAME				6
#define	D3286_MEAS_MODE_SPECIFIC_FIELD				7
#define	D3286_MEAS_MODE_OTHER_THAN_SPECIFIC_FIELD	8
#define	D3286_MEAS_MODE_ALL_FIELDS					9

// D3286_set_error_count_display_format() - format_id values
#define	D3286_DISPLAY_FORMAT_EXPONENTIAL			1
#define	D3286_DISPLAY_FORMAT_INTEGER				2

// D3286_set_error_count_display_format() - format_id values
#define	D3286_DISPLAY_FORMAT_PERCENT				1
#define	D3286_DISPLAY_FORMAT_INTERVAL_COUNT			2

// D3286_set_current_data_mode() - meas_horizon_id values
#define	D3286_DISPLAY_MEASUREMENT_CUMULATIVE		1
#define	D3286_DISPLAY_MEASUREMENT_PERIODIC			2

// D3286_configure_measurement_time() - meas_time_mode_id values
#define	D3286_MEASUREMENT_TIME_NORMAL				1
#define	D3286_MEASUREMENT_TIME_FRAME_TIME			2
#define	D3286_MEASUREMENT_TIME_FRAME_INTERVAL		3
#define	D3286_MEASUREMENT_TIME_BURST				4

// D3286_select_gate() - gate_id values
#define	D3286_GATE_INTERNAL							1
#define	D3286_GATE_EXTERNAL							2

// D3286_set_timer_mode() - timer_mode_id values
#define	D3286_TIMER_MODE_SINGLE						1
#define	D3286_TIMER_MODE_REPEAT						2
#define	D3286_TIMER_MODE_NO_TIMER					3

// D3286_set_time_display_mode() - time_display_mode_id values
#define	D3286_TIMER_DISPLAY_MODE_ELAPSED_TIME		1
#define	D3286_TIMER_DISPLAY_MODE_REMAINING_TIME		2
#define	D3286_TIMER_DISPLAY_MODE_CONTINUE_TIME		3
#define	D3286_TIMER_DISPLAY_MODE_INTERVAL_TIME		4
#define	D3286_TIMER_DISPLAY_MODE_BURST_TIME			5

void CVIFUNC D3286_configure_and_measure (void);

void CVIFUNC D3286_send_pattern (ViUInt32 frame_number, ViUInt32 row_number,
                                 ViUInt32 byte_number, ViUInt32 frame_byte_count);

ViStatus CVIFUNC D3286_configure_data_output (ViSession instrSession,
                                              int terminator_voltage_id,
                                              int input_polarity_id,
                                              ViReal64 output_offset_volts);

ViStatus CVIFUNC D3286_configure_clock_output_voltage (ViSession instrSession,
                                                       int terminator_voltage_id);

ViStatus CVIFUNC D3286_set_clock_delay (ViSession instrSession,
                                        ViInt32 clock_delay_ps);

ViStatus CVIFUNC D3286_execute_auto_search (ViSession instrSession);

ViStatus CVIFUNC D3286_set_pattern_mode (ViSession instrSession, int pattern_mode_id);

ViStatus CVIFUNC D3286_set_prbs_count_n (ViSession instrSession, ViUInt32 count_n);

ViStatus CVIFUNC D3286_set_mark_ratio (ViSession instrSession, int mark_ratio_id);

ViStatus CVIFUNC D3286_configure_trigger_output (ViSession instrSession,
                                                 int trigger_type_id);

ViStatus CVIFUNC D3286_set_pattern_trigger_address (ViSession instrSession,
                                                    ViUInt32 trigger_address);

ViStatus CVIFUNC D3286_set_prbs_pattern_trigger_addr (ViSession instrSession,
                                                      ViUInt32 prbs_trigger_address);

ViStatus CVIFUNC D3286_set_alternate_mode (ViSession instrSession,
                                           int alternate_mode_state);

ViStatus CVIFUNC D3286_select_alternate_pattern (ViSession instrSession,
                                                 int alternate_pattern_id);

ViStatus CVIFUNC D3286_set_word_pattern_length (ViSession instrSession,
                                                ViUInt32 word_pattern_length);

ViStatus CVIFUNC D3286_set_word_pattern_trigger_addr (ViSession instrSession,
                                                      ViUInt32 word_pattern_trigger_address);

ViStatus CVIFUNC D3286_set_word_sync (ViSession instrSession,
                                      ViUInt32 word_address, ViUInt32 bit_length);

ViStatus CVIFUNC D3286_set_word_mask_field (ViSession instrSession,
                                            ViUInt32 word_mask_field_start_address,
                                            ViUInt32 start_bit_number,
                                            ViUInt32 word_mask_field_end_address,
                                            ViUInt32 end_bit_number);

ViStatus CVIFUNC D3286_set_word_specific_field (ViSession instrSession,
                                                ViUInt32 word_mask_field_start_address,
                                                ViUInt32 start_bit_number,
                                                ViUInt32 word_mask_field_end_address,
                                                ViUInt32 end_bit_number);

ViStatus CVIFUNC D3286_send_word_pattern (ViSession instrSession,
                                          ViUInt32 word_address,
                                          ViUInt32 word_byte_count,
                                          unsigned char words_sent[]);

ViStatus CVIFUNC D3286_send_word_alternate_pattern (ViSession instrSession,
                                                    int word_alternate_pattern_id,
                                                    ViUInt32 word_address,
                                                    ViUInt32 word_byte_count,
                                                    unsigned char words_sent[]);

ViStatus CVIFUNC D3286_set_polarity (ViSession instrSession, int polarity_id);

ViStatus CVIFUNC D3286_set_payload_type (ViSession instrSession,
                                         int payload_type_id);

ViStatus CVIFUNC D3286_set_frame_structure (ViSession instrSession,
                                            ViUInt32 frame_count,
                                            ViUInt32 row_count,
                                            ViUInt32 byte_count_per_row,
                                            ViUInt32 overhead_byte_count,
                                            ViUInt32 cid_bit_count);

ViStatus CVIFUNC D3286_set_frame_pattern_trigger (ViSession instrSession,
                                                  ViUInt32 frame_number,
                                                  ViUInt32 row_number,
                                                  ViUInt32 byte_number);

ViStatus CVIFUNC D3286_set_frame_sync_word (ViSession instrSession,
                                            ViUInt32 frame_number,
                                            ViUInt32 row_number,
                                            ViUInt32 byte_number,
                                            ViUInt32 bit_number);

ViStatus CVIFUNC D3286_set_frame_mask_field (ViSession instrSession,
                                             ViUInt32 start_frame_number,
                                             ViUInt32 start_row_number,
                                             ViUInt32 start_word_number,
                                             ViUInt32 start_bit_number,
                                             ViUInt32 end_frame_number,
                                             ViUInt32 end_row_number,
                                             ViUInt32 end_word_number,
                                             ViUInt32 end_bit_number);

ViStatus CVIFUNC D3286_set_frame_specific_field (ViSession instrSession,
                                                 ViUInt32 start_frame_number,
                                                 ViUInt32 start_row_number,
                                                 ViUInt32 start_word_number,
                                                 ViUInt32 start_bit_number,
                                                 ViUInt32 end_frame_number,
                                                 ViUInt32 end_row_number,
                                                 ViUInt32 end_word_number,
                                                 ViUInt32 end_bit_number);

ViStatus CVIFUNC D3286_send_frame_pattern (ViSession instrSession,
                                           ViUInt32 frame_number,
                                           ViUInt32 row_number,
                                           ViUInt32 byte_number,
                                           ViUInt32 frame_byte_count,
                                           unsigned char frame_pattern_sent[]);

ViStatus CVIFUNC D3286_send_frame_alternate_pattern (ViSession instrSession,
                                                     int word_alternate_pattern_id,
                                                     ViUInt32 frame_number,
                                                     ViUInt32 row_number,
                                                     ViUInt32 byte_number,
                                                     ViUInt32 frame_byte_count,
                                                     unsigned char frame_pattern_sent[]);

ViStatus CVIFUNC D3286_set_frame_polarity (ViSession instrSession,
                                           int polarity_id);

ViStatus CVIFUNC D3286_configure_output (ViSession instrSession, int output_id,
                                         int output_mode_id, int offset_mode_id,
                                         ViReal64 amplitude_volt_pp,
                                         ViReal64 output_offset_volts,
                                         int adjust_enable);

ViStatus CVIFUNC D3286_set_timer_mode (ViSession instrSession, int timer_mode_id);

ViStatus CVIFUNC D3286_set_measurement_function (ViSession instrSession,
                                                 int meas_fct_id);

ViStatus CVIFUNC D3286_set_measurement_mode (ViSession instrSession,
                                             int meas_mode_id);

ViStatus CVIFUNC D3286_set_error_count_display_format (ViSession instrSession,
                                                       int format_id);

ViStatus CVIFUNC D3286_set_error_interval_disp_format (ViSession instrSession,
                                                       int format_id);

ViStatus CVIFUNC D3286_configure_current_display (ViSession instrSession,
                                                  int curr_data_id);

ViStatus CVIFUNC D3286_set_current_data_mode (ViSession instrSession,
                                              int meas_horizon_id);

ViStatus CVIFUNC D3286_configure_measurement_time (ViSession instrSession,
                                                   int meas_time_mode_id);

ViStatus CVIFUNC D3286_select_gate (ViSession instrSession, int gate_id);

ViStatus CVIFUNC D3286_start_measurements (ViSession instrSession);

ViStatus CVIFUNC D3286_stop_measurements (ViSession instrSession);

ViStatus CVIFUNC D3286_configure_auto_sync (ViSession instrSession,
                                            int auto_sync_state_id);

ViStatus CVIFUNC D3286_configure_frame_sync_for_word (ViSession instrSession,
                                                      int sync_state_id);

ViStatus CVIFUNC D3286_configure_frame_sync_for_frame (ViSession instrSession,
                                                       int sync_state_id);

ViStatus CVIFUNC D3286_execute_resync (ViSession instrSession);

ViStatus CVIFUNC D3286_configure_data_buzzer (ViSession instrSession,
                                              int buzzer_state_id);

ViStatus CVIFUNC D3286_configure_alarm_buzzer (ViSession instrSession,
                                               int buzzer_state_id);

ViStatus CVIFUNC D3286_set_time_mode (ViSession instrSession, int timer_mode_id);

ViStatus CVIFUNC D3286_set_time_display_mode (ViSession instrSession,
                                              int time_display_mode_id);

ViStatus CVIFUNC D3286_configure_meas_auto_print (ViSession instrSession,
                                                  int auto_print_state_id);

ViStatus CVIFUNC D3286_print_measurements (ViSession instrSession);

ViStatus CVIFUNC D3286_configure_error_auto_print (ViSession instrSession,
                                                   int auto_print_state_id);

ViStatus CVIFUNC D3286_printer_paper_feed (ViSession instrSession);

ViStatus CVIFUNC D3286_load_file (ViSession instrSession, int file_type_id,
                                  ViUInt32 file_number, int alternate_pattern_id);

ViStatus CVIFUNC D3286_save_file (ViSession instrSession, int file_type_id,
                                  ViUInt32 file_number, int alternate_pattern_id);

ViStatus CVIFUNC D3286_get_measurements (ViSession instrSession,
                                         ViReal64 *meas_result,
                                         ViUInt32 timeout_ms);

ViStatus CVIFUNC D3286_get_time (ViSession instrSession, ViChar meas_time[],
                                 ViUInt32 timeout_ms);
